// Fonts
@font-face {
    font-family: 'HandelGothic';
    font-weight: normal;
    src: url('../fonts/HandelGothic-Regular.ttf') format('truetype');
}

@font-face {
    font-family: 'SourceCodePro';
    font-weight: normal;
    src: url('../fonts/SourceCodePro-Regular.ttf') format('truetype');
}

@font-face {
    font-family: 'OpenSans';
    font-weight: normal;
    src: url('../fonts/OpenSans-Regular.ttf') format('truetype');
}

// Mixins
@mixin large {
    @media(min-width: 1200px) {
        @content;
    }
}

@mixin small {
    @media(max-width: 1199px) {
        @content;
    }
}

// General rules
* {
    box-sizing: border-box;
}

html, body {
    background-color: #000000;
    padding: 0;
    margin: 0;
    line-height: 1.5;
    font-family: "OpenSans", sans-serif;
    font-size: 16px;
}

h1, h2, h3, h4, h5, h6 {
    font-family: "HandelGothic", sans-serif;
    margin-top: 1em;
    margin-bottom: 0.5em;
}

h1 {
    display: none; // The banner takes care of the title
}

h2 {
    font-size: 3rem;
    margin-top: 1.5em;
    text-align: center;
    position: relative;
    z-index: 10;
    text-shadow: 0 0 1rem rgba(0, 0, 0, 1);

    &::after {
        content: '';
        position: absolute;
        background-image: radial-gradient(circle, rgba(21,140,179,1) 0%, rgba(0,193,255,0) 100%);
        width: 100%;
        height: 4px;
        top: calc(50% - 2px);
        left: 0;
        z-index: -1;
    }
}

h3 {
    font-size: 2rem;
}

h5 {
    text-align: center;
    font-size: 1rem;
}

a {
    color: #00c1ff;
    text-decoration: none;

    &:visited {
        color: #00c1ff;
    }

    &:active, &:focus, &:hover {
        color: white; 
    }
}

p > code {
   background-color: rgba(255, 255, 255, 0.2);
   padding: 0.4rem 0.4rem 0rem 0.4rem;
}

pre {
    content: '';
    inset: 0;
    padding: 1rem;
    overflow: auto;
    background-color: rgba(255, 255, 255, 0.2);
    clip-path: polygon(0 1rem,1rem 0,100% 0,100% calc(100% - 1rem),calc(100% - 1rem) 100%,0 100%);
}

progress {
    margin: 0 1rem;
}

body {
    background-color: #322B2B;
}

iframe {
    display: block;
    margin: 1rem auto;
}

.arrow {
    position: absolute;
    bottom: calc(9rem + 20px);
    left: 50%;
    transform: translate(-50%, -50%);
    cursor: pointer;

    span {
        display: block;
        width: 1.5vw;
        height: 1.5vw;
        border-bottom: 2px solid #00c1ff;
        border-right: 2px solid #00c1ff;
        transform: rotate(45deg);
        margin: -10px;
        animation: animate-arrow 2s infinite;

        &:nth-child(2) {
            animation-delay: -0.2s;
        }

        &:nth-child(3) {
            animation-delay: -0.4s;
        }
    }
}

.bg-video {
    pointer-events: none;
    position: fixed;
    top: 50%;
    left: 50%;
    width: 100%;
    height: 100%;
    max-width: 1024px;
    max-height: 1024px;
    transform: translate(-50%, -50%);
}

@keyframes animate-arrow {
    0% {
        opacity: 0;
        transform: rotate(45deg) translate(-20px, -20px);
    }
    50% {
        opacity: 1;
    }
    100% {
        opacity: 0;
        transform: rotate(45deg) translate(20px, 20px);
    }
}

// Site structure
.site {
    background-color: #000000;
    background-image: url('/img/bg.jpg');
    background-repeat: no-repeat;
    background-size: 768px 768px;
    background-position: center;
    background-attachment: fixed;
    min-height: 100vh;
    color: #e1e1e1;
    padding: calc(100vh - 6rem) 0 4rem 0;
    margin: 0;

    &::after {
        content: '';
        display: block;
        position: absolute;
        top: 0;
        left: 50%;
        transform: translateX(-50%);
        background-image: url('../img/banner-transparent.png');
        pointer-events: none;
        width: 100%;
        max-width: 60rem;
        height: 100%;
        background-size: contain;
        background-position: center;
        background-repeat: no-repeat;
    }

    &-main {
        width: calc(100% - 4rem);
        position: relative;
        margin: 0 auto;
        max-width: 60rem;
    }

    &-banner {
        display: block;
        width: 100%;
        max-width: 70rem;
        margin: 0 auto;
        height: 100%;
    }

    &-brand {
        display: block;
        text-align: left;
        position: absolute;
        top: 1rem;
        right: 1rem;;
        width: 100%;
        max-width: 12rem;
        opacity: 0.5;

        &:hover {
            opacity: 1.0;
        }

        img {
            display: block;
            width: 100%;
        }
    }

    &-title {
        display: none;
    }
}

// Native site elements
.tree {
    list-style-type: none;
    padding: 0;

    &-item {
        line-height: 2rem;

        summary {
            cursor: pointer;
        
            &:hover {
                text-decoration: underline;
            }
        }
    }

    .tree .tree-item {
        padding-left: 1rem;
    }
}

// Subsections
.admonition {
    position: relative;
    display: inline-block;
    z-index: 10;
    padding: 0.5rem 2.5rem 1rem 2.5rem;
    margin: 2rem 0;
    text-align: center;

    &-title {
        font-family: "HandelGothic", sans-serif;
        font-size: 1.5rem;
        text-transform: uppercase;
    }

    &.important {
        .admonition-title::before {
            content: '⚠️';
            margin-right: 1rem;
        }
        
        .admonition-title::after {
            content: '⚠️';
            margin-left: 1rem;
        }
    }

    &::after {
        content: '';
        position: absolute;
        inset: 0;
        background-color: #ffffff;
        z-index: -1;
        clip-path: polygon(0 1rem,1rem 0,100% 0,100% calc(100% - 1rem),calc(100% - 1rem) 100%,0 100%,0 1rem,1px  calc(1rem + 0.41px),1px calc(100% - 1px),calc(100% - 1rem - 0.41px) calc(100% - 1px),calc(100% - 1px) calc(100% - 1rem - 0.41px),calc(100% - 1px) 1px,calc(1rem + 0.41px) 1px,1px calc(1rem + 0.41px));
    }
}

.social {
    text-align: center;
    margin-bottom: 3rem;

    &-link {
        margin: 1rem;
        text-decoration: none;
        outline: 0;

        &:hover {
            text-decoration: none;
        }

        img {
            max-height: 3rem;
        }
    }
}

.download {
    text-align: center;
    
    &-link {
        position: relative;
        display: inline-block;
        z-index: 10;
        text-align: center;
        padding: 0.5rem 2.5rem 1rem 2.5rem;
        width: 100%;
        margin-bottom: 2rem;

        &::after {
            content: '';
            position: absolute;
            inset: 0;
            background-color: #00c1ff;
            z-index: -1;
            clip-path: polygon(0 1rem,1rem 0,100% 0,100% calc(100% - 1rem),calc(100% - 1rem) 100%,0 100%,0 1rem,1px  calc(1rem + 0.41px),1px calc(100% - 1px),calc(100% - 1rem - 0.41px) calc(100% - 1px),calc(100% - 1px) calc(100% - 1rem - 0.41px),calc(100% - 1px) 1px,calc(1rem + 0.41px) 1px,1px calc(1rem + 0.41px));
        }

        &:hover {
            text-decoration: none;
            color: white;

            &::before {
                content: '';
                position: absolute;
                inset: 0;
                z-index: -1;
                background-image: radial-gradient(circle, rgba(21,140,179,1) 0%, rgba(0,193,255,0.2) 100%);
                clip-path: polygon(0 1rem,1rem 0,100% 0,100% calc(100% - 1rem),calc(100% - 1rem) 100%,0 100%);
            }
        }

        &-name {
            margin: 0;
            font-family: "HandelGothic", sans-serif;
        }

        &-summary {
            margin: 0;
        }
    }
}

.install {
    text-align: center;

    > ul {
        text-align: left;
        display: inline-block;
        padding: 0;
    }

    ul {
        list-style-type: none;
    }
}

.gallery {
    &-images {
        display: flex;
        flex-wrap: wrap;
        justify-content: center;
        align-items: center;
    }
        
    &-image {
        margin: 0.5rem;
        cursor: pointer;

        input[type="checkbox"] {
            appearance: none;
            -webkit-appearance: none;
            background-color: transparent;
            position: absolute;
            margin: 0;
            padding: 0;

            &:checked {
                position: fixed;
                top: 0;
                left: 0;
                width: 100%;
                height: 100%;
                z-index: 20;
                background-image: url('/img/bg.jpg');
                background-size: cover;
                background-position: center;
                cursor: pointer;

                ~ img.gallery-image-full {
                    display: block;
                    position: fixed;
                    z-index: 30;
                    left: 50%;
                    top: 50%;
                    transform: translate(-50%, -50%);
                    max-height: calc(100% - 2rem);
                    max-width: calc(100% - 2rem);
                }

                ~ .gallery-image-title {
                    position: fixed;
                    display: block;
                    z-index: 31;
                    left: 50%;
                    bottom: 1rem;
                    transform: translate(-50%, -50%);
                    margin: 0;
                    padding: 0.5rem 1rem;
                    background-color: rgba(0, 0, 0, 0.5);
                    clip-path: polygon(0 1rem,1rem 0,100% 0,100% calc(100% - 1rem),calc(100% - 1rem) 100%,0 100%);
                }
            }
        }

        &-thumbnail {
            max-width: 10rem;
            max-height: 10rem;
            display: block;
            border: 1px solid transparent;
        
            &:hover {
                border-color: #00c1ff;
                box-shadow: 0 0 1rem #00c1ff;
            }
        }

        &-full, &-title {
            display: none;
        }
    }
}

.roadmap {
    &-toc {
        max-width: 30rem;
        margin: 0 auto;

        &-item {
            display: flex;

            a, span {
                flex-basis: 4rem;
                flex-shrink: 0;
            }

            progress {
                flex-grow: 1;
            }
        }
    }

    ul {
        list-style-type: none;

        li {
            line-height: 2rem;

            .task {
                display: inline-block;
                width: 0.9rem;
                height: 0.9rem;
                border-radius: 50%;
                border: 2px solid lightgrey;
                margin-right: 0.5rem;
                position: relative;
                color: white;
                
                &::after {
                    font-size: 0.5rem;
                    display: block;
                    position: absolute;
                    top: 50%;
                    left: 50%;
                    transform: translate(-40%, -48%);
                }

                &.-in-progress {
                    border: 0;
                    background-color: dodgerblue;
                
                    &::after {
                        content: '▶';
                    }
                }

                &.-done {
                    border: 0;
                    background-color: darkgreen;
                    
                    &::after {
                        content: '✔';
                    }
                }
            }
        }
    }
}

.credits {
    text-align: center;

    h4 {
        margin-bottom: 0;
    }

    p {
        margin-top: 0;
    }
}
